unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    PaintBox1: TPaintBox;
    msgtext: TStaticText;
    clearBtn: TBitBtn;
    solveBtn: TBitBtn;
    stopBtn: TBitBtn;
    Label2: TLabel;
    dimlabel: TLabel;
    helpBtn: TBitBtn;
    CheckBox1: TCheckBox;
    Timer1: TTimer;
    Button1: TButton;
    Image1: TImage;
    procedure PaintBox1Paint(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure dimlabelMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure dimlabelMouseEnter(Sender: TObject);
    procedure dimlabelMouseLeave(Sender: TObject);
    procedure dimlabelMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure clearBtnClick(Sender: TObject);
    procedure PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure PaintBox1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure stopBtnClick(Sender: TObject);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure solveBtnClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure CheckBox1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Image1Click(Sender: TObject);
    procedure helpBtnClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses timer_unit,shellApi;

const dimensions : array[1..7] of byte = (4,5,7,8,10,11,13);

type Tpos3 = (poEmpty,poH1,poH2,poH3,poV1,poV2,poV3,poCenter);
     TGreenPos = record
                  act : boolean;
                  x,y : byte;
                 end;
     Ttile3 = record
               dir : byte; //bit    1:right 2:up   4:left   8:down
               posX,posY : byte; //board positions
              end;
     TsearchResult = (srNo,srYes,srAbort);
     Tmove = record
              dir : char; //'H' or 'V'
              mx  : byte; //board coordinates
              my  : byte; //..
             end;

var dimcode : byte=5;
    dim : byte = 10;
    board : array[1..13,1..13] of TPos3;
    greenX : byte = 5;
    greenY : byte = 5;
    mapA,mapB,greenmap,H3tile,V3tile : Tbitmap;
    greentile : TGreenPos = (act: true; x:5; y:5);
    centerflag : boolean;
//--
    dcc : byte;    //draw control counter
    tile3 : Ttile3;
//--
    searchBusy : boolean;
    pauseFlag : boolean;
    abortflag : boolean;
//--
    movecount : byte;
    maxmove   : byte;
    RegFlag   : boolean; //suppress multiple registrations

procedure controledges(ctrl : Tcontrol; col1,col2 : longword; w : Byte);
var x1,x2,y1,y2 : word;
    i : byte;
begin
 x1 := ctrl.Left-w;
 y1 := ctrl.Top-w;
 x2 := ctrl.Left+ctrl.Width+w-1;
 y2 := ctrl.Top + ctrl.Height+w-1;
 with form1.Canvas do
  begin
   pen.Width := 1;
   pen.Color := $000000;
   for i := 0 to w-1do
    begin
     pen.color := col1;
     moveto(x2-i,y1+i);
     lineto(x1+i,y1+i);
     lineto(x1+i,y2-i);
     pen.Color := col2;
     lineto(x2-i,y2-i);
     lineto(x2-i,y1+i);
    end; 
  end;  
end;

procedure getSXY(var sx,sy:word; px,py:byte);
//sx,sy: screen (pixel) positions
begin
 sx := (px-1)*30+1;
 sy := (py-1)*30+1;
end;

procedure getPXY(var px,py: byte; x,y : smallInt);
//px,py : cell positions
begin
 px := (x div 30) + 1;
 py := (y div 30) + 1;
end;

procedure copymapA2B;
begin
 mapB.canvas.draw(0,0,mapA);
end;

procedure copymapB2Box;
begin
 form1.paintbox1.canvas.draw(0,0,mapB);
end;

procedure paintmapA;
var i : word;
begin
 with MapA do with canvas do
  begin
   brush.color := form1.color;
   brush.style := bsSolid;
   fillrect(rect(0,0,width,height));
   pen.width := 1;
   pen.color := $000000;
   i := 0;
   while i <= width do
    begin
     moveto(0,i);
     lineto(width,i);
     moveto(i,0);
     lineto(i,height);
     inc(i,30);
    end;
  end;
end;

procedure clearboard;
//does not affect center position
var i,j : byte;
begin
 for i := 1 to dim do
  for j:= 1 to dim do
   if (board[i,j] <> poCenter) then board[i,j] := poEmpty;
end;

procedure paintcenter(px,py : byte);
var sx,sy : word;
begin
 getSXY(sx,sy,px,py);
 mapB.Canvas.Draw(sx,sy,greenmap);
end;

procedure removeCenter;
begin
 with greentile do
  if act then begin
               board[x,y] := poEmpty;
               act := false;
              end;
end;

procedure setCenter(px,py : byte);
begin
 clearBoard;
 copymapA2B;
 removeCenter;
 with greentile do
  begin
   act := true;
   x := px;
   y := py;
  end;
 board[px,py] := poCenter;
 paintcenter(px,py);
 copymapB2Box;
 form1.msgtext.Caption := 'OK';
end;

procedure setmaxmove;
begin
 maxmove := (dim*dim-1) div 3;
 movecount := 0;
end; 

procedure paintHV3(dir : char; px,py : byte);
//dir 'H' , 'V'
var sx,sy : word;
begin
 getSXY(sx,sy,px,py);
 inc(sx);
 inc(sy);
 if dir = 'H' then mapB.Canvas.Draw(sx,sy,H3tile);
 if dir = 'V' then mapB.Canvas.Draw(sx,sy,V3tile);
 copymapB2Box;
end;

procedure paintDot3(ttl : TTile3);
var i : byte;
    col : longword;

  procedure sphere(x,y : byte);
  var sx,sy : word;
  begin
   getSXY(sx,sy,x,y);
   with mapB.Canvas do
    begin
     pen.Color := col;
     pen.Width := 1;
     brush.Color := col;
     brush.Style := bsSolid;
     ellipse(sx+2,sy+2,sx+28,sy+28);
    end;
  end;
begin
 with ttl do
  begin
   col := $0000ff;
   sphere(posX,posY);
   col := $00c0ff;
   for i := 0 to 3 do
    begin
     case i of
      0 : if dir and (1) > 0 then
           begin
            sphere(posX+1,posY);
            sphere(posX+2,posY);
           end;
      1 : if (dir and 2) > 0 then
           begin
            sphere(posX,posY-1);
            sphere(posX,posY-2);
          end;
      2 : if (dir and 4) > 0 then
           begin
            sphere(posX-1,posY);
            sphere(posX-2,posY);
           end;
      3 : if (dir and 8) > 0 then
           begin
            sphere(posX,posY+1);
            sphere(posX,posY+2);
          end;
     end;//case
    end; //for i
  end;   //with ttl
 copymapB2Box;
end;

procedure repaintmapB;
var i,j : byte;
begin
 copymapA2B;
 for i := 1 to dim do
  for j := 1 to dim do
   begin
    case board[i,j] of
     poCenter : paintCenter(i,j);
     poH1     : paintHV3('H',i,j);
     poV1     : paintHV3('V',i,j);
    end;//case
  end;//for
 copymapB2Box;
end;

procedure resetCenter;
begin
 with greentile do
  if act then
   begin
    board[x,y] := poCenter;
    paintCenter(x,y);
   end;
 copymapB2Box;
end;

procedure setdimensions;
//dim*dim
var d30 : word;
    r : Trect;
begin
 d30 := dim*30+1;
 with mapA do
  begin
   width := d30;
   height := d30;
  end;
 with mapB do
  begin
   width := d30;
   height := d30;
  end;
 with form1 do
  begin
   paintbox1.Width := d30;
   paintbox1.Height := d30;
   with canvas do
    begin
     brush.color := form1.color;
     brush.style := bsSolid;
     r.left := paintbox1.Left;
     r.top := paintbox1.Top;
     r.right := r.Left+301;
     r.bottom := r.Top+301;
     fillrect(r);
    end;
  end;
 paintmapA;
 copymapA2B;
 clearBoard;
end;

procedure createMap(var mp : Tbitmap);
var d : word;
begin
 d := 30*dim+1;
 mp := Tbitmap.Create;
 with mp do
  begin
   pixelformat := pf32bit;
   transparent := false;//
   height := d;
   width := d;
  end;
end;

procedure createTile3Map(var m : Tbitmap; w,h : byte);
//yellow tiles
var i : byte;
begin
 m := Tbitmap.Create;
 with m do
  begin
   pixelformat := pf32bit;
   width := w;
   height := h;
   with Canvas do
    begin
     brush.Color := $00ffff;
     brush.Style := bsSolid;
     fillrect(rect(0,0,w,h));
     dec(w);
     dec(h);
     for i := 0 to 1 do
      begin
       moveto(i,i);
       lineto(i,h-i);
       lineto(w-i,h-i);
       lineto(w-i,i);
       lineto(i,i);
      end;
    end;
  end;
end;

procedure creategreenmap;
begin
 greenmap := Tbitmap.create;
 with greenmap do with canvas do
  begin
   width := 29;
   height := 29;
   brush.style := bsSolid;
   brush.color := $101010;
   fillrect(rect(0,0,width,height));
   pen.color := $000000;
   pen.width := 1;
   brush.color := $00ff00;
   ellipse(2,2,26,26);
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 createmap(mapA);
 createmap(mapB);
 createGreenmap;
 createTile3Map(H3tile,87,27);
 createTile3Map(V3tile,27,87);
 setdimensions;  //includes paint mapA, copymapA to mapB
 resetCenter;
 setmaxmove;
 msgtext.Caption := 'welcome at the tiles puzzle';
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 mapA.Free;
 mapB.Free;
 greenmap.free;
 H3tile.Free;
 V3tile.Free;
end;

procedure TForm1.FormPaint(Sender: TObject);
begin
 controledges(dimlabel,$808080,$808080,2);
end;

procedure TForm1.PaintBox1Paint(Sender: TObject);
begin
 paintbox1.Canvas.Draw(0,0,mapB);
end;

procedure TForm1.dimlabelMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var s : string;
begin
 case button of
  mbleft  : if dimcode > 1 then dec(dimcode);
  mbright : if dimcode < 7 then inc(dimcode);
 end;
 dim := dimensions[dimcode];
 s := inttostr(dim);
 dimlabel.Caption := s+' * '+s;
 controledges(dimlabel,$000000,$f0f0f0,2);
 removeCenter;
 setdimensions;
 copymapB2Box;
 msgtext.caption := 'place green 1x1 tile';
end;

procedure TForm1.dimlabelMouseEnter(Sender: TObject);
begin
 controledges(dimlabel,$f0f0f0,$000000,2);
end;

procedure TForm1.dimlabelMouseLeave(Sender: TObject);
begin
 controledges(dimlabel,$808080,$808080,2);
end;

procedure TForm1.dimlabelMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 controledges(dimlabel,$f0f0f0,$000000,2);
 setmaxmove;
end;

//----game----

function tile3test(px,py : byte) : Ttile3;
begin
 with result do
  begin
   dir := 0;
   if board[px,py] <> poEmpty then exit;
   if (px <= dim-2) and (board[px+1,py]= poEmpty) and
                        (board[px+2,py]= poEmpty) then dir := dir or $1;
   if (py <= dim-2) and (board[px,py+1]= poEmpty) and
                        (board[px,py+2]= poEmpty) then dir := dir or $8;
   if (px >= 3)     and (board[px-1,py]= poEmpty) and
                        (board[px-2,py]= poEmpty) then dir := dir or $4;
   if (py >= 3)     and (board[px,py-1]= poEmpty) and
                        (board[px,py-2]= poEmpty) then dir := dir or $2;
   posX := px;
   posY := py;
  end;
end;

procedure movetext;
begin
 with form1.msgtext do
  if movecount = 0 then Caption := ''
  else
   if movecount = maxmove then Caption := 'Congratulations ! Puzzle is solved.'
    else caption := 'move '+inttostr(movecount)+' / '+inttostr(maxmove);
end;

procedure deleteDot3(ttl : TTile3);
var sx,sy : word;
    r : Trect;
    i : byte;
begin
 with ttl do
  begin
   getSXY(sx,sy,posX,posY);
   for i := 0 to 3 do
    if (dir and (1 shl i)) > 0 then
     begin
      case i of
       0 : begin
            r.Left := sx;
            r.Top := sy;
            r.right := sx+90;
            r.Bottom := sy+30;
           end;
       1 : begin
            r.Left := sx;
            r.Top := sy-60;
            r.Right := sx + 30;
            r.Bottom := sy+30;
           end;
       2 : begin
            r.Left := sx-60;
            r.Top := sy;
            r.Right := sx+30;
            r.Bottom := sy+30;
           end;
       3 : begin
            r.Left := sx;
            r.Top := sy;
            r.Right := sx+30;
            r.Bottom := sy+90;
           end;
    end;//case
    mapB.Canvas.CopyRect(r,mapA.Canvas,r);
    form1.PaintBox1.canvas.copyrect(r,mapB.Canvas,r);
   end;
 end;
end;

procedure registertile(d : byte);
begin
 with tile3 do
  case d of
   1 : begin                        //right
        board[posX,posY]   := poH1;
        board[posX+1,posY] := poH2;
        board[posX+2,posY] := poH3;
        paintHV3('H',posX,posY);
       end;
   2 : begin                        //up
        board[posX,posY-2] := poV1;
        board[posX,posY-1] := poV2;
        board[posX,posY]   := poV3;
        paintHV3('V',posX,posY-2);
       end;
   4 : begin                        //left
        board[posX,posY]   := poH3;
        board[posX-1,posY] := poH2;
        board[posX-2,posY] := poH1;
        paintHV3('H',posX-2,posY);
       end;
   8 : begin                        //down
        board[posX,posY]   := poV1;
        board[posX,posY+1] := poV2;
        board[posX,posY+2] := poV3;
        paintHV3('V',posX,posY);
       end;
  end;
 copymapB2Box;
 inc(movecount);
 movetext;
end;

procedure deleteFromBoard(dir : char; px,py : byte);
var sx,sy : word;
    r : Trect;
    i : byte;
begin
 getSXY(sx,sy,px,py);
 r.left := sx;
 r.Top := sy;
 if dir = 'H' then
  begin
   r.right := r.left+90;
   r.Bottom := r.Top+30;
   for i := 0 to 2 do board[px+i,py] := poEmpty;
  end
  else begin
        r.Right := r.Left+30;
        r.Bottom := r.Top+90;
        for i := 0 to 2 do board[px,py+i] := poEmpty;
       end;
 mapB.Canvas.CopyRect(r,mapA.Canvas,r);
 form1.PaintBox1.canvas.copyrect(r,mapB.Canvas,r);
end;

procedure removetile3(x,y : byte);
var OK: boolean;
    ch : char;
begin
 OK := true;
 case board[x,y] of
  poH1 : begin
          ch := 'H';
         end;
  poH2 : begin
          ch := 'H';
          dec(x);
         end;
  poH3 : begin
          ch := 'H';
          dec(x,2);
         end;
  poV1 : begin
          ch := 'V';
         end;
  poV2 : begin
          ch := 'V';
          dec(y);
         end;
  poV3 : begin
          ch := 'V';
          dec(y,2);
         end; 
  else begin
        OK := false;
        ch := ' ';
       end; 
 end;
 if OK then begin
             deleteFromBoard(ch,x,y);
             dec(movecount);
             movetext;
            end; 
end;

procedure TForm1.PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var px,py : byte;
begin
 if searchbusy then exit;
 getPXY(px,py,x,y);
 if board[px,py] = poCenter then begin
                                  centerflag := true;
                                  exit;
                                 end;
 if greentile.act = false then begin
                                setCenter(px,py);
                                exit;
                               end
  else dcc := 1;
 if (board[px,py] >= poH1) and (board[px,py] <= poV3) then
  begin
   removetile3(px,py);
   dcc := 2;
   exit;
  end;
end;

procedure debug(sx,sy : word);
//move over board to see contents
var px,py : byte;
    s : string;
begin
 getPXY(px,py,sx,sy);
 case board[px,py] of
  poCenter : s := 'center';
  poH1     : s := 'H1';
  poH2     : s := 'H2';
  poH3     : s := 'H3';
  poV1     : s := 'V';
  poV2     : s := 'V2';
  poV3     : s := 'V3';
  poEmpty  : s := 'empty';
 end;
 form1.msgtext.Caption := s;
end;

procedure TForm1.PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var px,py : byte;
    newtile3 : Ttile3;
    dir : byte;//direction 1,2,4,8
begin
// if searchbusy then debug(x,y);
 if searchbusy then exit;
// 
 if greentile.act = false then exit;
//
 if x < 0 then x := 0;
 if y < 0 then y := 0;
 if centerflag then
  begin
   getPXY(px,py,x,y);
   if px > dim then px := dim;
   if py > dim then py := dim;
   if (px <> greentile.x) or (py <> greentile.y) then
    begin
     removecenter;
     setcenter(px,py);
     exit;
    end;
  end;
//
 getPXY(px,py,x,y);
 case dcc of
  0 : begin
       newtile3 := tile3test(px,py);
       if (newtile3.dir = tile3.dir) and
          (newtile3.posx = tile3.posx) and
          (newtile3.posy = tile3.posy) then exit;
//
       if tile3.dir > 0 then deleteDot3(tile3);
       if newtile3.dir > 0 then paintDot3(newtile3);
       tile3 := newtile3;
      end;
  1 : begin
       dir := 0;
       if ((tile3.dir and $1) > 0) and                  //right
          ((px-tile3.posX) > 0) and
          (py = tile3.posY) then dir := 1;

       if dir = 0 then
        if ((tile3.dir and $8) > 0) and                 //down
           ((py-tile3.posY) > 0) and
           (px = tile3.posX) then dir := 8;

       if dir=0 then
        if ((tile3.dir and $2) > 0) and                //up
           ((tile3.posY-py) > 0) and
           (px = tile3.posX) then dir := 2;

       if dir=0 then
        if ((tile3.dir and $4) > 0) and                //left
           ((tile3.posX-px) > 0) and
           (py = tile3.posY) then dir := 4;

       if dir > 0 then if regflag = false then
                        begin
                         deletedot3(tile3);
                         registerTile(dir);
                         regFlag := true;
                        end;
      end;
 end;//case
end;

procedure TForm1.PaintBox1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 if searchbusy then exit;
 dcc := 0;
 with tile3 do
  begin
   dir := 0;
   posX := 0;
   posY := 0;
  end;
 RegFlag := false;
 Centerflag := false;
end;

procedure TForm1.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
 if searchbusy then exit;
//
 if tile3.dir > 0 then begin
                        deleteDot3(tile3);
                        tile3.dir := 0;
                       end;
end;

procedure TForm1.clearBtnClick(Sender: TObject);
var i,j : byte;
    Full : boolean; //detected full cell
begin
 activecontrol := nil;
 dcc := 0;
 full := false;
 copymapA2B;
 for i := 1 to dim do
  for j := 1 to dim do
   if (board[i,j] <> poEmpty) and (board[i,j] <> poCenter) then
    begin
     board[i,j] := poEmpty;
     full := true;
    end;
 with greentile do
  if full then resetCenter
   else removeCenter;
 copymapB2Box;
 if greentile.act =false then msgtext.caption := 'place green tile.'
  else msgtext.Caption := '';
 setmaxmove;
 RegFlag := false;
 searchbusy := false;
end;

procedure Showboard;
var i,j : byte;
begin
 copymapA2B;
 with greentile do paintcenter(x,y);
 for i := 1 to dim do
  for j := 1 to dim do
   case board[i,j] of
    poH1 : paintHV3('H',i,j);
    poV1 : paintHV3('V',i,j);
   end;//case
  copymapB2Box;
end;

procedure searchpause;
begin
 pauseFlag := true;
 while pauseFlag do application.ProcessMessages;
end;

function GOsearch : TsearchResult;
var x,y : byte;  //board position
    moveNr : byte;
    movelist : array[1..56] of TMove;
    i : byte;
    timeout : longword;
    proctime : longword;
    s : string;

label freelabel,Vlabel,backlabel;

 function nextfreecell(var x,y : byte) : boolean;
 var tx,ty : byte;
 begin
  tx := x;
  ty := y;
  result := false;
  repeat
   if board[tx,ty] = poEmpty then begin
                                   result := true;
                                   x := tx;
                                   y := ty;
                                  end
    else begin
          inc(tx);
          if tx > dim then begin
                            tx := 1;
                            inc(ty);
                           end;
         end;
  until (result) or (ty > dim);
 end;

 function HorOK : boolean;
 begin
  result := (x <= dim-2) and (board[x+1,y]=poEmpty) and (board[x+2,y]=poEmpty);
 end;

 function VertOK : boolean;
 begin
  result := (y <= dim-2) and (board[x,y+1]=poEmpty) and (board[x,y+2]=poEmpty);
 end;  

 procedure removeHV;
 begin
  with movelist[moveNr] do
   begin
    x := mx; y := my;
   end;
  board[x,y] := poEmpty;
  if movelist[moveNr].dir = 'H' then
   begin
    board[x+1,y] := poEmpty;
    board[x+2,y] := poEmpty;
   end
   else begin
         board[x,y+1] := poEmpty;
         board[x,y+2] := poEmpty;
        end;
 end;

 procedure AddH;
 begin
  board[x,y] := poH1;
  board[x+1,y] := poH2;
  board[x+2,y] := poH3;
  with movelist[moveNr] do
   begin
    dir:= 'H';
    mx := x;
    my := y;
   end;
 end;

 procedure AddV;
 begin
  board[x,y] := poV1;
  board[x,y+1] := poV2;
  board[x,y+2] := poV2;
  with movelist[moveNr] do
   begin
    dir := 'V';
    mx := x;
    my := y;
   end
 end;

begin
 for i := 1 to 56 do movelist[i].dir := 'N';
 moveNr := 0;
 x := 1;
 y := 1;
 timeout := 1000000;
 proctime := gettickcount;

freelabel:

  if form1.CheckBox1.Checked then
   begin
    if moveNr > 0 then
     begin
      form1.msgtext.Caption := 'move '+inttostr(moveNr)+' pause:'+
                               ' Press <space> for next move';
      showboard;
      searchpause;
     end;
   end else begin
             dec(timeout);
             if timeout = 0 then
              begin
               timeout := 1000000;
               showboard;
               application.ProcessMessages;
               s := 'searching '+
                    inttostr(round((gettickcount-proctime)/1000))+' secs.';
               form1.msgtext.Caption := s;
              end;
            end;
  if abortflag then begin
                     result := srAbort;
                     exit;
                    end;

 if nextfreecell(x,y) = false then
  begin
   result := srYes;
   exit;
  end;

 if HorOK then begin
                inc(moveNr);
                AddH;
                goto freelabel;
               end;

Vlabel:

 if VertOK then begin
                 inc(moveNr);
                 AddV;
                 goto Freelabel;
                end;

backlabel:

 if moveNr = 0 then begin
                     result := srNO;
                     exit;
                    end;
//
 removeHV;
 x := movelist[moveNr].mx;
 y := movelist[moveNr].my;
 if movelist[moveNr].dir = 'H' then
  begin
   dec(moveNr);
   goto Vlabel;
  end
  else begin
        dec(moveNr);
        goto Backlabel;
       end;
end;

procedure TForm1.stopBtnClick(Sender: TObject);
begin
 activecontrol := nil;
 abortFlag := true;
end;

procedure TForm1.solveBtnClick(Sender: TObject);
var t1,t2 : Int64;
    Searchresult : Tsearchresult;
    searchtime : double;
    s,st : string;
begin
 activecontrol := nil;
 if searchbusy then exit;
 clearboard;
 abortflag := false;
 pauseflag := false;
 searchbusy := true;
 t1 := getCPUticks;
 searchResult := Gosearch;
 t2 := getCPUticks;
 searchtime := procTime(t2-t1);
 st := formatfloat('###0.###',searchtime*1e-3)+' msecs';
 case searchresult of
  srNo    : s := 'No solution.';
  srYes   : s := 'Solution found.'+' (' + st + ')';
  srAbort : s := 'Search ended.';
 end;//case
 showboard;
 msgText.Caption := s;
 searchbusy := false;
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if searchbusy then
  if key = VK_SPACE then pauseflag := false;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
 activecontrol := nil;
end;

procedure TForm1.Button1Click(Sender: TObject);
//debug:  time control
//hidden button
var ticks : longword;
    t1    : Int64;
    eltime : word;
    clock : longword;
begin
 t1 := getCPUticks;
 ticks := gettickcount;
 repeat
  eltime := round(proctime(getCPUticks-t1)*1e-6);
  clock := round((gettickcount-ticks)*1e-3);
 until clock = 1;
 msgtext.Caption := inttostr(eltime);
end;

procedure TForm1.Image1Click(Sender: TObject);
//DavData image
begin
 ShellExecute(0,'open','http://www.davdata.nl/math/index.html', nil, nil, SW_SHOWNORMAL);
end;

procedure TForm1.helpBtnClick(Sender: TObject);
begin
 activecontrol := nil;
 ShellExecute(0,'open','http://www.davdata.nl/tile-puzzle.html', nil, nil, SW_SHOWNORMAL);
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 abortflag := true;
 pauseFlag := false;
end;

end.
